<!DOCTYPE html>
<html lang="en"><head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
		<title>three.js webgl - lines - cubes</title>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0">
		<style>
			body {
				background-color: #000000;
				margin: 0px;
				overflow: hidden;
			}

			a {
				color:#0078ff;
			}

			#info {
				position: absolute;
				top: 10px; width: 100%;
				color: #ffffff;
				padding: 5px;
				font-family: Monospace;
				font-size: 13px;
				text-align: center;
				z-index:100;
			}

			a {
				color: orange;
				text-decoration: none;
			}

			a:hover {
				color: #0080ff;
			}

		</style>
	</head>
	<body>

		<div id="info">
			[<a href="http://en.wikipedia.org/wiki/Hilbert_curve">Hilbert curve</a> mapping of Ethereum private keys to public keys and public addresses.]
			This is step one in demostrating the mapping: unit cubes :)
		</div>

		<script src="three.js"></script>

		<script src="hilbert3D.js"></script>

		<script src="Detector.js"></script>
		<script src="stats.js"></script>

		<script>

			if ( ! Detector.webgl ) Detector.addGetWebGLMessage();


			var chosenLines = [];
			var chosenConnector = new THREE.Line3();
			var geocontainer = new THREE.Geometry();
			var materialOfChosenConnector = new THREE.LineBasicMaterial( { color: 0x00FF00, opacity: 1, blending: THREE.AdditiveBlending, transparent:true});

			var firstPoint, secondPoint;

			function updateConnector() {
				//console.log(chosenLines[0].matrixWorld)  //works!

				//this still important
				chosenConnector.set(chosenLines[0].getWorldPosition().addScaledVector(secondPoint, 0.5), chosenLines[1].getWorldPosition().addScaledVector(firstPoint, 0.5));

				//console.log("Distance ", chosenConnector.distance());
				//console.log("getCenter " ,chosenConnector.getCenter());
				console.log("getWorldPosition 0 ", chosenLines[0].getWorldPosition().addScaledVector(secondPoint, 0.5));
				console.log("getWorldPosition 1 ", chosenLines[1].getWorldPosition().addScaledVector(firstPoint, 0.5));
				//geocontainer.vertices.push(chosenLines[0].getWorldPosition());
				//geocontainer.vertices.push(chosenLines[1].getWorldPosition());
				//chosenLines[0].getWorldPosition();
				//chosenLines[1].getWorldPosition();
				//make new line segment connecting those two midpoints

				var dir = chosenLines[0].getWorldPosition().addScaledVector(secondPoint, 0.5).sub(chosenLines[1].getWorldPosition().addScaledVector(firstPoint, 0.5));
				//normalize the direction vector (convert to vector of length 1)
				dir.normalize();

				var origin = chosenLines[1].getWorldPosition().addScaledVector(firstPoint, 0.5);
				var length = chosenConnector.distance();
				var hex = 0x00ff00;

				var arrowHelper = new THREE.ArrowHelper( dir, origin, length, hex );
				scene.add( arrowHelper );

			}





			var mouseX = 0, mouseY = 0,

			windowHalfX = window.innerWidth / 2,
			windowHalfY = window.innerHeight / 2,

			camera, scene, renderer;

			init();
			animate();


			function init() {

				var i, container;

				container = document.createElement( 'div' );
				document.body.appendChild( container );

				camera = new THREE.PerspectiveCamera( 33, window.innerWidth / window.innerHeight, 1, 10000 );
				camera.position.z = 700;

				scene = new THREE.Scene();

				renderer = new THREE.WebGLRenderer();
				renderer.setPixelRatio( window.devicePixelRatio );
				renderer.setSize( window.innerWidth, window.innerHeight );
				container.appendChild( renderer.domElement );

				var hilbertIterations = 4;
				var geometry = new THREE.Geometry(),
					points = hilbert3D( new THREE.Vector3( 0,0,0 ), 200.0, hilbertIterations, 0, 1, 2, 3, 4, 5, 6, 7 );

					//Location highlighting code
					// ChosenOne function (key) {... returns [octant, octant, octant, octant]}
				//	var exampleChosenOne = [[1,0,1],[0,0,1],[0,1,0],[1,1,0]]
				var geometryOfChosenOne = new THREE.Geometry()
				var geometryOfChosenOne2 = new THREE.Geometry()
				var materialOfChosenOne = new THREE.LineBasicMaterial( { color: 0x0000FF, opacity: 1, blending: THREE.AdditiveBlending, transparent:true})
				var materialOfChosenOne2 = new THREE.LineBasicMaterial( { color: 0xFF0000, opacity: 1, blending: THREE.AdditiveBlending, transparent:true})

				//var hilbertPoints = hilbert3D( new THREE.Vector3( 0,0,0 ), 200.0, hilbertIterations, 0, 1, 2, 3, 4, 5, 6, 7 );
				//console.log(hilbertPoints);
				//best base for this problem octal?
				//binaryToDecimal(101) = 5
				// var newArray = [oldArray[5]];
				var randompoint1 = ~~(Math.random()*points.length)
				console.log(randompoint1)
				var chosenVertices = [points[randompoint1],points[randompoint1+1]];
				geometryOfChosenOne.vertices.push(chosenVertices[0]);
				geometryOfChosenOne.vertices.push(chosenVertices[1]);
				//firstPoint = points[randompoint1];
				//console.log("firstPoint = ", points[4]);

				var randompoint2 = ~~(points.length*Math.random())
				console.log(randompoint2)
				var chosenVertices2 = [points[randompoint2],points[randompoint2+1]];
				geometryOfChosenOne2.vertices.push(chosenVertices2[0]);
				geometryOfChosenOne2.vertices.push(chosenVertices2[1]);
				//secondPoint = points[randompoint2];
				//console.log("secondPoint = ", secondPoint)

				var midpoint1 = new THREE.Vector3;
				midpoint1.addScaledVector(chosenVertices[0],0.5).addScaledVector(chosenVertices[1],0.5)
				console.log("midpoint1",midpoint1)
				firstPoint = midpoint1;

				var midpoint2 = new THREE.Vector3;
				midpoint2.addScaledVector(chosenVertices2[0],0.5).addScaledVector(chosenVertices2[1],0.5)
				console.log("midpoint2",midpoint2)
				secondPoint = midpoint2;

				for ( i = 0; i < points.length; i ++ ) {

					geometry.vertices.push( points[i] );

				}
				// lines
				var line, p, scale = 0.5, d = 100, c1 = 0x553300, g1 = geometry,
					m1 = new THREE.LineBasicMaterial( { color: c1, opacity: 0.5, blending: THREE.AdditiveBlending, transparent: true } )//,c2 = 0x555555, c3 = 0x992800,,
					m2 = new THREE.LineBasicMaterial( { color: c1, opacity: 0.5, blending: THREE.AdditiveBlending, transparent: true } ),
					//m3 = new THREE.LineBasicMaterial( { color: c3, opacity: 1, blending: THREE.AdditiveBlending, transparent: true } ),

					parameters =
										[
											//[ m3, scale*.7, [d,0,0],  g1 ],
										  [ m2, scale, [d, 0, 0],  g1 ],
											[ materialOfChosenOne2, scale, [d, 0, 0], geometryOfChosenOne2],
											[ m1, scale, [-d, 0, 0],  g1 ],
											[ materialOfChosenOne, scale, [-d, 0, 0], geometryOfChosenOne]
								   ];

				for ( i = 0; i < parameters.length; i ++ ) {

					p = parameters[ i ];

					line = new THREE.Line( p[ 3 ],  p[ 0 ] );

					line.scale.x = line.scale.y = line.scale.z =  p[ 1 ];

					line.position.x = p[ 2 ][ 0 ];
					line.position.y = p[ 2 ][ 1 ];
					line.position.z = p[ 2 ][ 2 ];

					scene.add( line );
					if (i % 2 != 0){
						chosenLines.push(line);
					}

				}

				console.log(chosenLines);
				updateConnector();
				//var comeON = THREE.Line(geocontainer ,materialOfChosenConnector);
				//comeON.scale.x = comeON.scale.y = comeON.scale.z = 1;
				//comeON.position.x = comeON.position.y = comeON.position.z = 1;
				//scene.add(comeON);

				document.addEventListener( 'mousemove', onDocumentMouseMove, false );
				document.addEventListener( 'touchstart', onDocumentTouchStart, false );
				document.addEventListener( 'touchmove', onDocumentTouchMove, false );

				//

				window.addEventListener( 'resize', onWindowResize, false );

			}

			function onWindowResize() {

				windowHalfX = window.innerWidth / 2;
				windowHalfY = window.innerHeight / 2;

				camera.aspect = window.innerWidth / window.innerHeight;
				camera.updateProjectionMatrix();

				renderer.setSize( window.innerWidth, window.innerHeight );

			}

			//

			function onDocumentMouseMove(event) {

				mouseX = event.clientX - windowHalfX;
				mouseY = event.clientY - windowHalfY;
			}

			function onDocumentTouchStart( event ) {

				if ( event.touches.length > 1 ) {

					event.preventDefault();

					mouseX = event.touches[ 0 ].pageX - windowHalfX;
					mouseY = event.touches[ 0 ].pageY - windowHalfY;

				}

			}

			function onDocumentTouchMove( event ) {

				if ( event.touches.length == 1 ) {

					event.preventDefault();

					mouseX = event.touches[ 0 ].pageX - windowHalfX;
					mouseY = event.touches[ 0 ].pageY - windowHalfY;

				}

			}

			//

			function animate() {

				//updateConnector()  // is this where this belongs, and not in a prerender event listener?

				requestAnimationFrame( animate );

				render();

			}

			function render() {

				camera.position.x += ( mouseX - camera.position.x ) * .05;
				camera.position.y += ( - mouseY + 200 - camera.position.y ) * .05;

				camera.lookAt( scene.position );

				var time = Date.now() * 0.0015;

				for ( var i = 0; i < scene.children.length; i ++ ) {

					var object = scene.children[ i ];
					// temporary no spin  //
					//if ( object instanceof THREE.Line || 1 ) object.rotation.y = time;// * ( i % 2 ? 1 : -1 );
					//updateConnector();
				}

				renderer.render( scene, camera );

			}

		</script><div><canvas width="738" height="639" style="width: 738px; height: 639px;"></canvas></div>


</body></html>
